// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package internetmonitor provides the client and types for making API
// requests to Amazon CloudWatch Internet Monitor.
//
// Amazon CloudWatch Internet Monitor provides visibility into how internet
// issues impact the performance and availability between your applications
// hosted on Amazon Web Services and your end users, reducing the time it takes
// for you to diagnose these issues, from days to minutes. You can explore internet
// measurements for different time frames and at different geographic granularities,
// and quickly visualize the impact of issues, and then take action to improve
// your end users' experience, for example, by switching to other Amazon Web
// Services services or rerouting traffic to your workload through differentAmazon
// Web Services Regions.
//
// If the issue is caused by the Amazon Web Services network, you'll automatically
// receive an Amazon Web Services Health Dashboard notification with the steps
// that Amazon Web Services is taking to mitigate the problem. To support integrating
// health information for geographies and networks specific to your application,
// Internet Monitor delivers measurements to CloudWatch Logs and CloudWatch
// Metrics. Internet Monitor also sends health events to Amazon EventBridge,
// so you can set up notifications. Internet Monitor monitors internet connectivity
// for your application through Amazon Virtual Private Clouds (VPCs), Amazon
// CloudFront distributions, and Amazon WorkSpaces directories.
//
// To use Internet Monitor, you create a monitor and add resources to it, Virtual
// Private Clouds (VPCs), Amazon CloudFront distributions, or WorkSpaces directories
// that show where your application's internet traffic is. Internet Monitor
// then provides internet measurements from Amazon Web Services that are specific
// to the locations and networks that communicate with your application. For
// more information, see Using Amazon CloudWatch Internet Monitor (https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/CloudWatch-InternetMonitor.html)
// in the Amazon CloudWatch User Guide.
//
// See https://docs.aws.amazon.com/goto/WebAPI/internetmonitor-2021-06-03 for more information on this service.
//
// See internetmonitor package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/internetmonitor/
//
// # Using the Client
//
// To contact Amazon CloudWatch Internet Monitor with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Amazon CloudWatch Internet Monitor client InternetMonitor for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/internetmonitor/#New
package internetmonitor
